#line 1 "ext/ohcount_native/ragel_parsers/matlab.rl"
// matlab.rl written by Mitchell Foral. mitchell<att>caladbolg<dott>net.

/************************* Required for every parser *************************/
#ifndef RAGEL_MATLAB_PARSER
#define RAGEL_MATLAB_PARSER

#include "ragel_parser_macros.h"

// the name of the language
const char *MATLAB_LANG = "matlab";

// the languages entities
const char *matlab_entities[] = {
  "space", "comment", "string", "any",
};

// constants associated with the entities
enum {
  MATLAB_SPACE = 0, MATLAB_COMMENT, MATLAB_STRING, MATLAB_ANY
};

/*****************************************************************************/


#line 27 "ext/ohcount_native/ragel_parsers/matlab.h"
static const char _matlab_actions[] = {
	0, 1, 0, 1, 1, 1, 5, 1, 
	6, 1, 9, 1, 10, 1, 11, 1, 
	12, 1, 14, 1, 15, 1, 18, 1, 
	19, 1, 20, 1, 21, 1, 22, 1, 
	24, 1, 25, 1, 26, 1, 27, 1, 
	28, 2, 1, 7, 2, 3, 1, 2, 
	4, 2, 2, 6, 16, 2, 7, 17, 
	2, 8, 10, 2, 10, 23, 2, 13, 
	7, 2, 13, 10, 3, 4, 2, 0, 
	3, 13, 0, 7
};

static const char _matlab_cond_offsets[] = {
	0, 0, 0, 0, 0, 0, 1, 2, 
	3, 3, 3, 3, 3, 3, 3, 3, 
	3, 4, 4, 4, 4, 4, 4
};

static const char _matlab_cond_lengths[] = {
	0, 0, 0, 0, 0, 1, 1, 1, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	1, 0, 0, 0, 0, 0, 0
};

static const short _matlab_cond_keys[] = {
	13, 13, 13, 13, 13, 13, 13, 13, 
	0
};

static const char _matlab_cond_spaces[] = {
	0, 0, 0, 0, 0
};

static const char _matlab_key_offsets[] = {
	0, 0, 1, 3, 8, 11, 22, 33, 
	45, 46, 51, 54, 55, 60, 63, 66, 
	67, 81, 83, 88, 91, 92, 97
};

static const short _matlab_trans_keys[] = {
	37, 37, 125, 10, 34, 92, 12, 13, 
	10, 12, 13, 9, 10, 12, 32, 37, 
	269, 525, -128, 11, 14, 127, 9, 10, 
	12, 32, 37, 269, 525, -128, 11, 14, 
	127, 9, 10, 12, 32, 37, 125, 269, 
	525, -128, 11, 14, 127, 10, 10, 39, 
	92, 12, 13, 10, 12, 13, 10, 32, 
	35, 37, 9, 13, 32, 9, 13, 10, 
	12, 13, 123, 9, 10, 12, 32, 34, 
	35, 37, 39, 269, 525, -128, 8, 14, 
	127, 9, 32, 10, 34, 92, 12, 13, 
	10, 12, 13, 123, 10, 39, 92, 12, 
	13, 10, 0
};

static const char _matlab_single_lengths[] = {
	0, 1, 2, 3, 1, 7, 7, 8, 
	1, 3, 1, 1, 3, 1, 1, 1, 
	10, 2, 3, 1, 1, 3, 1
};

static const char _matlab_range_lengths[] = {
	0, 0, 0, 1, 1, 2, 2, 2, 
	0, 1, 1, 0, 1, 1, 1, 0, 
	2, 0, 1, 1, 0, 1, 0
};

static const char _matlab_index_offsets[] = {
	0, 0, 2, 5, 10, 13, 23, 33, 
	44, 46, 51, 54, 56, 61, 64, 67, 
	69, 82, 85, 90, 93, 95, 100
};

static const char _matlab_indicies[] = {
	2, 1, 2, 3, 1, 4, 6, 7, 
	4, 5, 4, 4, 5, 9, 10, 10, 
	9, 11, 12, 10, 8, 8, 4, 14, 
	15, 15, 14, 16, 17, 15, 13, 13, 
	4, 9, 10, 10, 9, 11, 18, 12, 
	10, 8, 8, 4, 10, 4, 4, 6, 
	20, 4, 19, 4, 4, 19, 21, 22, 
	24, 25, 26, 24, 23, 24, 24, 27, 
	28, 28, 25, 1, 30, 32, 21, 21, 
	32, 33, 34, 35, 36, 37, 38, 31, 
	31, 22, 32, 32, 39, 40, 6, 7, 
	40, 5, 41, 41, 42, 44, 43, 40, 
	6, 20, 40, 19, 21, 45, 0
};

static const char _matlab_trans_targs[] = {
	12, 1, 2, 12, 16, 3, 16, 4, 
	5, 5, 6, 7, 8, 5, 5, 6, 
	7, 8, 16, 9, 10, 16, 0, 12, 
	13, 14, 15, 12, 12, 12, 14, 16, 
	17, 18, 19, 20, 21, 11, 22, 16, 
	16, 16, 19, 19, 5, 16
};

static const char _matlab_trans_actions[] = {
	39, 11, 11, 59, 29, 0, 19, 0, 
	1, 0, 0, 1, 0, 68, 47, 47, 
	68, 47, 17, 0, 0, 50, 0, 31, 
	9, 11, 65, 33, 35, 37, 56, 53, 
	5, 72, 41, 62, 72, 7, 7, 21, 
	27, 23, 0, 44, 3, 25
};

static const char _matlab_to_state_actions[] = {
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 13, 0, 0, 0, 
	13, 0, 0, 0, 0, 0, 0
};

static const char _matlab_from_state_actions[] = {
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 15, 0, 0, 0, 
	15, 0, 0, 0, 0, 0, 0
};

static const char _matlab_eof_trans[] = {
	0, 1, 1, 5, 5, 5, 5, 5, 
	5, 5, 5, 0, 0, 28, 29, 30, 
	0, 40, 41, 42, 41, 41, 46
};

static const int matlab_start = 12;
static const int matlab_first_final = 12;
static const int matlab_error = 0;

static const int matlab_en_matlab_line = 16;
static const int matlab_en_matlab_entity = 12;

#line 88 "ext/ohcount_native/ragel_parsers/matlab.rl"


/************************* Required for every parser *************************/

/* Parses a string buffer with MATLAB code.
 *
 * @param *buffer The string to parse.
 * @param length The length of the string to parse.
 * @param count Integer flag specifying whether or not to count lines. If yes,
 *   uses the Ragel machine optimized for counting. Otherwise uses the Ragel
 *   machine optimized for returning entity positions.
 * @param *callback Callback function. If count is set, callback is called for
 *   every line of code, comment, or blank with 'lcode', 'lcomment', and
 *   'lblank' respectively. Otherwise callback is called for each entity found.
 */
void parse_matlab(char *buffer, int length, int count,
  void (*callback) (const char *lang, const char *entity, int start, int end)
  ) {
  init

  
#line 183 "ext/ohcount_native/ragel_parsers/matlab.h"
	{
	cs = matlab_start;
	ts = 0;
	te = 0;
	act = 0;
	}
#line 109 "ext/ohcount_native/ragel_parsers/matlab.rl"
  cs = (count) ? matlab_en_matlab_line : matlab_en_matlab_entity;
  
#line 193 "ext/ohcount_native/ragel_parsers/matlab.h"
	{
	int _klen;
	unsigned int _trans;
	short _widec;
	const char *_acts;
	unsigned int _nacts;
	const short *_keys;

	if ( p == pe )
		goto _test_eof;
	if ( cs == 0 )
		goto _out;
_resume:
	_acts = _matlab_actions + _matlab_from_state_actions[cs];
	_nacts = (unsigned int) *_acts++;
	while ( _nacts-- > 0 ) {
		switch ( *_acts++ ) {
	case 12:
#line 1 "ext/ohcount_native/ragel_parsers/matlab.rl"
	{ts = p;}
	break;
#line 215 "ext/ohcount_native/ragel_parsers/matlab.h"
		}
	}

	_widec = (*p);
	_klen = _matlab_cond_lengths[cs];
	_keys = _matlab_cond_keys + (_matlab_cond_offsets[cs]*2);
	if ( _klen > 0 ) {
		const short *_lower = _keys;
		const short *_mid;
		const short *_upper = _keys + (_klen<<1) - 2;
		while (1) {
			if ( _upper < _lower )
				break;

			_mid = _lower + (((_upper-_lower) >> 1) & ~1);
			if ( _widec < _mid[0] )
				_upper = _mid - 2;
			else if ( _widec > _mid[1] )
				_lower = _mid + 2;
			else {
				switch ( _matlab_cond_spaces[_matlab_cond_offsets[cs] + ((_mid - _keys)>>1)] ) {
	case 0: {
		_widec = (short)(128 + ((*p) - -128));
		if ( 
#line 9 "ext/ohcount_native/ragel_parsers/matlab.rl"
 p+1 < pe && *(p+1) != '\n'  ) _widec += 256;
		break;
	}
				}
				break;
			}
		}
	}

	_keys = _matlab_trans_keys + _matlab_key_offsets[cs];
	_trans = _matlab_index_offsets[cs];

	_klen = _matlab_single_lengths[cs];
	if ( _klen > 0 ) {
		const short *_lower = _keys;
		const short *_mid;
		const short *_upper = _keys + _klen - 1;
		while (1) {
			if ( _upper < _lower )
				break;

			_mid = _lower + ((_upper-_lower) >> 1);
			if ( _widec < *_mid )
				_upper = _mid - 1;
			else if ( _widec > *_mid )
				_lower = _mid + 1;
			else {
				_trans += (_mid - _keys);
				goto _match;
			}
		}
		_keys += _klen;
		_trans += _klen;
	}

	_klen = _matlab_range_lengths[cs];
	if ( _klen > 0 ) {
		const short *_lower = _keys;
		const short *_mid;
		const short *_upper = _keys + (_klen<<1) - 2;
		while (1) {
			if ( _upper < _lower )
				break;

			_mid = _lower + (((_upper-_lower) >> 1) & ~1);
			if ( _widec < _mid[0] )
				_upper = _mid - 2;
			else if ( _widec > _mid[1] )
				_lower = _mid + 2;
			else {
				_trans += ((_mid - _keys)>>1);
				goto _match;
			}
		}
		_trans += _klen;
	}

_match:
	_trans = _matlab_indicies[_trans];
_eof_trans:
	cs = _matlab_trans_targs[_trans];

	if ( _matlab_trans_actions[_trans] == 0 )
		goto _again;

	_acts = _matlab_actions + _matlab_trans_actions[_trans];
	_nacts = (unsigned int) *_acts++;
	while ( _nacts-- > 0 )
	{
		switch ( *_acts++ )
		{
	case 0:
#line 53 "ext/ohcount_native/ragel_parsers/matlab.rl"
	{
  if (!line_contains_code && !line_start) line_start = ts;
  line_contains_code = 1;
}
	break;
	case 1:
#line 58 "ext/ohcount_native/ragel_parsers/matlab.rl"
	{
  if (!line_contains_code) {
    whole_line_comment = 1;
    if (!line_start) line_start = ts;
  }
}
	break;
	case 2:
#line 31 "ext/ohcount_native/ragel_parsers/matlab.rl"
	{
    switch(entity) {
    case MATLAB_SPACE:
      ls
      break;
    case MATLAB_ANY:
      code
      break;
    case INTERNAL_NL:
      std_internal_newline(MATLAB_LANG)
      break;
    case NEWLINE:
      std_newline(MATLAB_LANG)
    }
  }
	break;
	case 3:
#line 48 "ext/ohcount_native/ragel_parsers/matlab.rl"
	{ p--; }
	break;
	case 4:
#line 51 "ext/ohcount_native/ragel_parsers/matlab.rl"
	{ entity = INTERNAL_NL; }
	break;
	case 5:
#line 64 "ext/ohcount_native/ragel_parsers/matlab.rl"
	{ entity = MATLAB_SPACE; }
	break;
	case 6:
#line 67 "ext/ohcount_native/ragel_parsers/matlab.rl"
	{ entity = NEWLINE;      }
	break;
	case 7:
#line 68 "ext/ohcount_native/ragel_parsers/matlab.rl"
	{ entity = MATLAB_ANY;   }
	break;
	case 8:
#line 77 "ext/ohcount_native/ragel_parsers/matlab.rl"
	{ p--; }
	break;
	case 9:
#line 83 "ext/ohcount_native/ragel_parsers/matlab.rl"
	{ entity = MATLAB_SPACE;   }
	break;
	case 10:
#line 84 "ext/ohcount_native/ragel_parsers/matlab.rl"
	{ entity = MATLAB_COMMENT; }
	break;
	case 13:
#line 1 "ext/ohcount_native/ragel_parsers/matlab.rl"
	{te = p+1;}
	break;
	case 14:
#line 65 "ext/ohcount_native/ragel_parsers/matlab.rl"
	{te = p+1;}
	break;
	case 15:
#line 66 "ext/ohcount_native/ragel_parsers/matlab.rl"
	{te = p+1;}
	break;
	case 16:
#line 31 "ext/ohcount_native/ragel_parsers/matlab.rl"
	{te = p+1;{
    switch(entity) {
    case MATLAB_SPACE:
      ls
      break;
    case MATLAB_ANY:
      code
      break;
    case INTERNAL_NL:
      std_internal_newline(MATLAB_LANG)
      break;
    case NEWLINE:
      std_newline(MATLAB_LANG)
    }
  }}
	break;
	case 17:
#line 31 "ext/ohcount_native/ragel_parsers/matlab.rl"
	{te = p+1;{
    switch(entity) {
    case MATLAB_SPACE:
      ls
      break;
    case MATLAB_ANY:
      code
      break;
    case INTERNAL_NL:
      std_internal_newline(MATLAB_LANG)
      break;
    case NEWLINE:
      std_newline(MATLAB_LANG)
    }
  }}
	break;
	case 18:
#line 31 "ext/ohcount_native/ragel_parsers/matlab.rl"
	{te = p;p--;{
    switch(entity) {
    case MATLAB_SPACE:
      ls
      break;
    case MATLAB_ANY:
      code
      break;
    case INTERNAL_NL:
      std_internal_newline(MATLAB_LANG)
      break;
    case NEWLINE:
      std_newline(MATLAB_LANG)
    }
  }}
	break;
	case 19:
#line 65 "ext/ohcount_native/ragel_parsers/matlab.rl"
	{te = p;p--;}
	break;
	case 20:
#line 31 "ext/ohcount_native/ragel_parsers/matlab.rl"
	{te = p;p--;{
    switch(entity) {
    case MATLAB_SPACE:
      ls
      break;
    case MATLAB_ANY:
      code
      break;
    case INTERNAL_NL:
      std_internal_newline(MATLAB_LANG)
      break;
    case NEWLINE:
      std_newline(MATLAB_LANG)
    }
  }}
	break;
	case 21:
#line 31 "ext/ohcount_native/ragel_parsers/matlab.rl"
	{te = p;p--;{
    switch(entity) {
    case MATLAB_SPACE:
      ls
      break;
    case MATLAB_ANY:
      code
      break;
    case INTERNAL_NL:
      std_internal_newline(MATLAB_LANG)
      break;
    case NEWLINE:
      std_newline(MATLAB_LANG)
    }
  }}
	break;
	case 22:
#line 31 "ext/ohcount_native/ragel_parsers/matlab.rl"
	{{p = ((te))-1;}{
    switch(entity) {
    case MATLAB_SPACE:
      ls
      break;
    case MATLAB_ANY:
      code
      break;
    case INTERNAL_NL:
      std_internal_newline(MATLAB_LANG)
      break;
    case NEWLINE:
      std_newline(MATLAB_LANG)
    }
  }}
	break;
	case 23:
#line 73 "ext/ohcount_native/ragel_parsers/matlab.rl"
	{te = p+1;{
    callback(MATLAB_LANG, matlab_entities[entity], cint(ts), cint(te));
  }}
	break;
	case 24:
#line 86 "ext/ohcount_native/ragel_parsers/matlab.rl"
	{te = p+1;}
	break;
	case 25:
#line 73 "ext/ohcount_native/ragel_parsers/matlab.rl"
	{te = p;p--;{
    callback(MATLAB_LANG, matlab_entities[entity], cint(ts), cint(te));
  }}
	break;
	case 26:
#line 73 "ext/ohcount_native/ragel_parsers/matlab.rl"
	{te = p;p--;{
    callback(MATLAB_LANG, matlab_entities[entity], cint(ts), cint(te));
  }}
	break;
	case 27:
#line 86 "ext/ohcount_native/ragel_parsers/matlab.rl"
	{te = p;p--;}
	break;
	case 28:
#line 86 "ext/ohcount_native/ragel_parsers/matlab.rl"
	{{p = ((te))-1;}}
	break;
#line 532 "ext/ohcount_native/ragel_parsers/matlab.h"
		}
	}

_again:
	_acts = _matlab_actions + _matlab_to_state_actions[cs];
	_nacts = (unsigned int) *_acts++;
	while ( _nacts-- > 0 ) {
		switch ( *_acts++ ) {
	case 11:
#line 1 "ext/ohcount_native/ragel_parsers/matlab.rl"
	{ts = 0;}
	break;
#line 545 "ext/ohcount_native/ragel_parsers/matlab.h"
		}
	}

	if ( cs == 0 )
		goto _out;
	if ( ++p != pe )
		goto _resume;
	_test_eof: {}
	if ( p == eof )
	{
	if ( _matlab_eof_trans[cs] > 0 ) {
		_trans = _matlab_eof_trans[cs] - 1;
		goto _eof_trans;
	}
	}

	_out: {}
	}
#line 111 "ext/ohcount_native/ragel_parsers/matlab.rl"

  // if no newline at EOF; callback contents of last line
  if (count) { process_last_line(MATLAB_LANG) }
}

#endif

/*****************************************************************************/
